package Uploader::GUI::DlgCommon;
use strict;

use base qw/
               Class::Accessor::Fast
           /; 

__PACKAGE__->mk_accessors(     
    qw/
        properties
      /
);


sub SetProperties {
    my ( $self ) = @_;
	
	map {
        my $ctrl =$self->FindWindow($_);
        #printf("ctrl %s : %s\n", $_, $ctrl);		
        if(defined $ctrl){
		# checkbox, static text
		$ctrl->SetLabel(
           $self->properties->{$_}->{label}
		) if exists$self->properties->{$_}->{label};

        $ctrl->SetValue(
           $self->properties->{$_}->{value}->()
		) if exists$self->properties->{$_}->{value};

        # radiobox
        my $labels =$self->properties->{$_}->{labels};
		$labels||=[];
		for(my $i=0; $i < scalar @$labels ; $i++){
		    $ctrl->SetItemLabel($i, $labels->[$i]);
		}
		# only works for control with items
		$ctrl->SetSelection(
		    $self->properties->{$_}->{selection}->()			
		) if exists $self->properties->{$_}->{selection};
		
		}
    }
	keys %{$self->properties};
}

sub GetProperties {
    my ( $self ) = @_;

	map {
        my $ctrl = $self->FindWindow($_);
        #printf("ctrl %s : %s\n", $_, $ctrl);		
        if(defined $ctrl){
		# checkbox, static text

        $self->properties->{$_}->{value}->(
            $ctrl->GetValue()
		) if exists $self->properties->{$_}->{value};

        $self->properties->{$_}->{selection}->(
		    $ctrl->GetSelection()			
		) if exists $self->properties->{$_}->{selection};
		
		}
    }
	keys %{$self->properties};
}
1;